clear;
clc;
close all;

% Test to show specific results
I = im2double(imread('Pics/3.jpg'));

% apply artificial blur 
len = 15;
theta = 45;
nsr_est = 0.0001;
psf = fspecial('motion', len, theta);
cfft = psf2otf(psf, size(I));
Ifft = fft2(I);
Ib = real(ifft2(Ifft.*cfft));

% brighten picture
Ibright = Ib .* 5;
Ibright(Ibright > 1) = 1;
[rows, cols, ch] = size(Ibright);
% imshow(Ibright);

Ideblur_ground_truth = deconvwnr(Ibright, psf, nsr_est);

%%
test_len = 15;
test_theta = 212;
nsr_est = 0.0001;

psf_test = fspecial('motion', test_len, test_theta);
Ideblur_test = deconvwnr(Ibright, psf_test, nsr_est);
    
% check quality of image (sharpness)
Ideblur_test_fft = fft2(rgb2gray(Ideblur_test));
Ideblur_test_fft_abs = abs(Ideblur_test_fft);
threshold = max(max(Ideblur_test_fft_abs))/1000;
Itest_pass = (abs(Ideblur_test_fft)) < threshold;
num_thresh_pass = sum(Itest_pass, 'all');

figure;
subplot(1,2,1);
imshow(Ideblur_test);
title("Wrong Theta");
subplot(1,2,2);
Ideblur_test_fft=fftshift(abs(Ideblur_test_fft));
imshow(Ideblur_test_fft);
title("Frequency Domain");